Imports System.Windows.Forms
Imports System.Reflection
Imports System.Drawing
Imports Microsoft.Vsa
Imports Microsoft.VisualBasic.Vsa

Public Class DrawingForm
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents picCanvas As System.Windows.Forms.PictureBox
    Friend WithEvents MainMenu1 As System.Windows.Forms.MainMenu
    Friend WithEvents MenuItem1 As System.Windows.Forms.MenuItem
    Friend WithEvents mnuFileScript As System.Windows.Forms.MenuItem
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.picCanvas = New System.Windows.Forms.PictureBox
        Me.MainMenu1 = New System.Windows.Forms.MainMenu
        Me.MenuItem1 = New System.Windows.Forms.MenuItem
        Me.mnuFileScript = New System.Windows.Forms.MenuItem
        Me.SuspendLayout()
        '
        'picCanvas
        '
        Me.picCanvas.Dock = System.Windows.Forms.DockStyle.Fill
        Me.picCanvas.Location = New System.Drawing.Point(0, 0)
        Me.picCanvas.Name = "picCanvas"
        Me.picCanvas.Size = New System.Drawing.Size(296, 285)
        Me.picCanvas.TabIndex = 0
        Me.picCanvas.TabStop = False
        '
        'MainMenu1
        '
        Me.MainMenu1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItem1})
        '
        'MenuItem1
        '
        Me.MenuItem1.Index = 0
        Me.MenuItem1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuFileScript})
        Me.MenuItem1.Text = "&File"
        '
        'mnuFileScript
        '
        Me.mnuFileScript.Index = 0
        Me.mnuFileScript.Shortcut = System.Windows.Forms.Shortcut.F5
        Me.mnuFileScript.Text = "&Script"
        '
        'DrawingForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(296, 285)
        Me.Controls.Add(Me.picCanvas)
        Me.Menu = Me.MainMenu1
        Me.Name = "DrawingForm"
        Me.Text = "DrawingForm"
        Me.ResumeLayout(False)

    End Sub

#End Region

    ' Store information for a line segment.
    Private Structure Segment
        Public x1, y1, x2, y2 As Integer
        Public SegmentColor As Color

        Public Sub New(ByVal x1 As Integer, ByVal y1 As Integer, ByVal x2 As Integer, ByVal y2 As Integer, ByVal segment_color As Color)
            Me.x1 = x1
            Me.y1 = y1
            Me.x2 = x2
            Me.y2 = y2
            SegmentColor = segment_color
        End Sub

        Public Sub Draw(ByVal gr As Graphics)
            Dim the_pen As New Pen(SegmentColor)
            gr.DrawLine(the_pen, x1, y1, x2, y2)
            the_pen.Dispose()
        End Sub
    End Structure
    Private m_Segments As New Collection

    ' Add a Segment to the drawing.
    Public Sub MakeSegment(ByVal x1 As Integer, ByVal y1 As Integer, ByVal x2 As Integer, ByVal y2 As Integer, ByVal line_color As Color)
        m_Segments.Add(New Segment(x1, y1, x2, y2, line_color))
    End Sub

    ' Redraw.
    Public Sub Redraw()
        picCanvas.Invalidate()
    End Sub

    ' Let the user write and execute a script.
    Private Sub mnuFileScript_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileScript.Click
        Dim dlg As New dlgScript
        If dlg.ShowDialog() = Windows.Forms.DialogResult.OK Then
            RunScript(dlg.txtScript.Text)
        End If
    End Sub

    Private Sub RunScript(ByVal script As String)
        Dim vsa_engine As New VsaEngine
        Dim vsa_site As New MyVsaSite(Me)

        ' Initialize the engine.
        vsa_engine.RootMoniker = "VsaExample://Picture/Draw"
        vsa_engine.Site = vsa_site
        vsa_engine.InitNew()
        vsa_engine.RootNamespace = "MyScriptTest"

        ' Empty the cache in case there is code in the GAC.
        vsa_engine.RevokeCache()

        ' Generate debug information when compiling.
        vsa_engine.GenerateDebugInfo = True

        ' Get a refernece to the Items collection.
        Dim items As IVsaItems = vsa_engine.Items

        ' Load system.dll and mscorelib.
        Dim reference_item As IVsaReferenceItem
        reference_item = CType( _
            items.CreateItem("system.dll", VsaItemType.Reference, VsaItemFlag.None), _
            IVsaReferenceItem)
        reference_item.AssemblyName = "system.dll"

        reference_item = CType( _
            items.CreateItem("mscorlib.dll", VsaItemType.Reference, VsaItemFlag.None), _
            IVsaReferenceItem)
        reference_item.AssemblyName = "mscorlib.dll"

        reference_item = CType( _
            items.CreateItem("system.drawing.dll", VsaItemType.Reference, VsaItemFlag.None), _
            IVsaReferenceItem)
        reference_item.AssemblyName = "system.drawing.dll"

        ' Load a reference to this assembly.
        ' Note that VB doesn't support EXEs, only DLLs.
        Dim assembly_name As String = [Assembly].GetExecutingAssembly.Location
        reference_item = CType( _
            items.CreateItem(assembly_name, VsaItemType.Reference, VsaItemFlag.None), _
            IVsaReferenceItem)
        reference_item.AssemblyName = assembly_name

        ' Load a global form object.
        Dim global_item As IVsaGlobalItem
        global_item = CType( _
            items.CreateItem("TheForm", VsaItemType.AppGlobal, VsaItemFlag.None), _
            IVsaGlobalItem)
        global_item.TypeString = "MainForm.DrawingForm"

        ' Load the script code. The name of this item
        ' must match the script's Module name to get global
        ' items to work.
        Dim codeItem As IVsaCodeItem = _
            CType(items.CreateItem("Script", VsaItemType.Code, VsaItemFlag.None), _
            IVsaCodeItem)
        codeItem.SourceText = script

        ' Compile the script code.
        vsa_engine.Compile()

        ' If the compilation failed, exit.
        If Not vsa_engine.IsCompiled() Then
            vsa_engine.Close()
            Exit Sub
        End If

        ' Start the engine.
        vsa_engine.Run()

        ' Execute sub MyScriptTest.Script.Main().
        ' <engine.RootNamespace>.<Module>.<Subroutine>
        Dim vsa_assembly As [Assembly] = vsa_engine.Assembly
        Dim my_type As Type = _
            vsa_assembly.GetType(vsa_engine.RootNamespace & ".Script")
        Dim method_info As MethodInfo = my_type.GetMethod("Main")
        method_info.Invoke(Nothing, Nothing)

        ' Clean up.
        vsa_engine.Close()
    End Sub

    ' Draw the segments.
    Private Sub picCanvas_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles picCanvas.Paint
        e.Graphics.Clear(picCanvas.BackColor)
        For Each seg As Segment In m_Segments
            seg.Draw(e.Graphics)
        Next seg
    End Sub
End Class

Public Class MyVsaSite
    Implements IVsaSite

    Public m_DrawingForm As DrawingForm

    ' Save the DrawingForm.
    Public Sub New(ByVal drawing_form As DrawingForm)
        m_DrawingForm = drawing_form
    End Sub

    Public Sub GetCompiledState(ByRef pe() As Byte, ByRef debugInfo() As Byte) Implements Microsoft.Vsa.IVsaSite.GetCompiledState
        Trace.WriteLine("IVsaSite.GetCompiledState()")
        pe = Nothing
        debugInfo = Nothing
    End Sub

    ' Return an event source instance.
    Public Function GetEventSourceInstance(ByVal itemName As String, ByVal eventSourceName As String) As Object Implements Microsoft.Vsa.IVsaSite.GetEventSourceInstance
        Trace.WriteLine(String.Format("IVsaSite.GetEventSourceInstance('{0}', '{1}')", itemName, eventSourceName))
        Select Case (eventSourceName)
            Case "TheForm"
                Return m_DrawingForm
            Case Else
                Throw New VsaException(VsaError.EventSourceTypeInvalid)
        End Select
    End Function

    ' Return a global instance.
    Public Function GetGlobalInstance(ByVal name As String) As Object Implements Microsoft.Vsa.IVsaSite.GetGlobalInstance
        Select Case name
            Case "TheForm"
                Return m_DrawingForm
            Case Else
                Throw New VsaException(VsaError.GlobalInstanceInvalid)
        End Select
    End Function

    Public Sub Notify(ByVal notify As String, ByVal info As Object) Implements Microsoft.Vsa.IVsaSite.Notify

    End Sub

    Public Function OnCompilerError(ByVal [error] As Microsoft.Vsa.IVsaError) As Boolean Implements Microsoft.Vsa.IVsaSite.OnCompilerError
        ' Compose the error message.
        Dim msg1 As String = _
            "Error on line " & [error].Line & vbCr & vbCr
        Dim msg2 As String = _
            [error].LineText & vbCr

        ' Display the message.
        Dim dlg As New dlgError
        dlg.rchError.Text = msg1 & msg2 & [error].Description
        dlg.rchError.Select( _
            Len(msg1) + [error].StartColumn - 1, _
            [error].EndColumn - [error].StartColumn + 1)
        dlg.rchError.SelectionColor = Color.Red
        dlg.rchError.SelectionFont = New Font(dlg.rchError.SelectionFont, FontStyle.Bold)
        If dlg.ShowDialog() = DialogResult.OK Then
            ' Continue to report errors.
            Return True
        Else
            ' Stop reporting errors.
            Return False
        End If
    End Function
End Class
